Is Regression:
Subject: Mysql Socket connection fails.
Description

A connection via socket fails because the socket part is taken as the port wich ist wrong and results in a connection exception.

From the PHP Dokumentation:
The MySQL server parameter: It can also include a port number. e.g. "hostname:port or a path to a local socket e.g." for the localhost.

Related issues:
related to Core - Task # 47455: Separate DB TYPO3_CONF_VARS settings host and... Resolved 2013-04-22
related to Core - Bug # 49186: Install tool: DB port setting magic Resolved 2013-06-24 2013-06-24

Associated revisions
Revision da7a0de4 - 2013-07-05 21:54 - Philipp Gampe

[BUGFIX] Support mysql socket connection

With the switch to mysqli in 6.1, the connection to mysql server via
socket broke.
With mysqli, the definition is now:
    -  If hostname is "localhost", a socket is used and the socket file

can be given optionally if it is different from the default.
    -  If hostname is not "localhost" but an IP address, a port can be

given that may be different from the default mysql 3306.

The patch now reflects this in the database connect step and adds a
parameter for the optional socket location. The patch will be adapted
for 6.1 to include only the additional optional socket parameter.

Resolves: #48117
Related: #49162
Releases: 6.2, 6.1
Change-Id: I968a72dbaf90b3f319c03e697137630534d325c1
Reviewed-on: https://review.typo3.org/20933
Reviewed-by: Christian Kuhn
Tested-by: Christian Kuhn
Reviewed-by: Markus Klein
Tested-by: Markus Klein

Revision 7381ca27 - 2013-07-05 23:22 - Philipp Gampe
[BUGFIX] Support mysql socket connection
With the switch to mysqli in 6.1, the connection to mysql server via
socket broke.
With mysqli, the definition is now:
    -  If hostname is "localhost", a socket is used and the socket file

can be given optionally if it is different from the default.
    -  If hostname is not "localhost" but an IP address, a port can be

given that may be different from the default mysql 3306.

This backport just considers the LocalConfiguration.php setting and
does not change anything in the installer.

Resolves: #48117
Releases: 6.2, 6.1
Change-Id: I968a72dbaf90b3f319c03e697137630534d325c1
Reviewed-on: https://review.typo3.org/21973
Reviewed-by: Markus Klein
Reviewed-by: Christian Kuhn
Tested-by: Christian Kuhn

History
#1 - 2013-05-12 14:26 - Wouter Wolters

Hi Jaro,

We do not use MySQL but MySQLi in TYPO3 6.1. So there needs to be a change to support the Socket parameter.
http://nl3.php.net/manual/en/mysqli.real-connect.php

I will contact the person who implemented the new code in this area.

#2 - 2013-05-16 22:09 - Jaro von Flocken

Hi Wouter,

this would be the cleanest way having an option for port number OR socket. Otherwise the solution would be detecting the type of the content behind
the ":" char (string or integer).

Does it help providing you with a patch?

cheers,

Jaro

#3 - 2013-05-17 06:00 - Philipp Gampe
- Status changed from New to Needs Feedback

@Jaro, it would be really cool if you would provide a patch.

We need a new install tool setting and support for this setting in the connect method.
If you want, you can also push this to our review server:
http://wiki.typo3.org/Contribution_Walkthrough_Tutorials

#4 - 2013-05-17 10:03 - Alexander Opitz

Does #47455 "Separate DB TYPO3_CONF_VARS settings host and port" helps? (This doesn't have a install option yet).

#5 - 2013-05-19 22:27 - Philipp Gampe
- Status changed from Needs Feedback to Accepted
- Complexity set to easy

@Alexander, no as the PHP API is not different ... we need a specific Install Tool setting for socket and we need to use this in bootstrap and
DatabaseConnection.

#6 - 2013-05-20 15:40 - Philipp Gampe
- Assigned To set to Philipp Gampe
- % Done changed from 0 to 20

#7 - 2013-05-20 17:02 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20933

#8 - 2013-06-20 21:46 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20933

#9 - 2013-06-21 03:32 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20933

#10 - 2013-06-21 03:36 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20933

#11 - 2013-06-21 03:43 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20933
#12 - 2013-07-05 17:18 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20933

#13 - 2013-07-05 18:35 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20933

#14 - 2013-07-05 22:19 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-1 has been pushed to the review server.
It is available at https://review.typo3.org/21973

#15 - 2013-07-05 22:27 - Gerrit Code Review

Patch set 2 for branch TYPO3_6-1 has been pushed to the review server.
It is available at https://review.typo3.org/21973

#16 - 2013-07-05 22:30 - Philipp Gampe
- Status changed from Under Review to Resolved
- % Done changed from 20 to 100

Applied in changeset commit:da7a0de4178e850da927bda5478dbe5ddc3d001b.
